#include <CtrlLib/CtrlLib.h>

using namespace Upp;

class App : public TopWindow {
public:
	typedef App CLASSNAME;
	App();

	void MenuBar(Bar& bar);
	void Stub() { }
	void Do();
	void Work();
};

App::App()
{
	Title("MenuBar::Execute test");
	Sizeable().Zoomable();
	const Size sz(320, 240);
	SetMinSize(sz); SetRect(sz);

	PostCallback(THISBACK(Do));
}

void App::MenuBar(Bar& bar)
{
	bar.Add("One", THISBACK(Stub));
	bar.Add("Two", THISBACK(Stub));
	bar.Add("Three", THISBACK(Stub));
}

void App::Do()
{
	SetTimeCallback(-10, THISBACK(Work), 1);
}

void App::Work()
{
	static int c = 0;
	const int n = 100;

	if (c++ < n)
		MenuBar::Execute(THISBACK(MenuBar), Point(n - c, n - c));
	else {
		KillTimeCallback(1);
		SetFocus();
		return;
	}
}

GUI_APP_MAIN
{
	App app;
	app.Run();
}
